%!TEX root = main.tex
% In order to realize the above mentioned functions,
% a strong platform support is needed.
% Based on PicoScenes Driver we designed and implemented picoscene platform.
% We encapsulate each network card as an abstract object to
% enable complex functions support at the top layer.
% PicoScenes can broadcast data packages through UDP which enables the receiver to generate a real-time view of CSI steam.
% We also developed a remote control function based on RESTful service.

% Besides the above functions

% PicoScenes Platform, as the second tier of the system, is an powerful runtime library.

Compared to the accompanied user-space programs of the existing system,
PicoScenes goes much beyond a simple CSI data logger.
Embracing the versatility of the mission-specific measurement tasks, 
PicoScenes adopts ``Platform + Plug-ins'' architecture, 
rather than one single monolithic APP.
%
Guided by this principle, 
PicoScenes Platform, 
provides a bunch of clean yet powerful APIs, 
such as 
fabricating and injecting HT-format packets, 
receiving RxS data from NIC array,
manipulating NIC Tx/Rx parameters,
on-line CSI data processing,
and even UDP-based RxS data streaming to support CSI live plot.
%
High performance is the other concern.
Written in C++17 and built upon asynchronous I/O and multithreading technologies,
PicoScenes Platform achieves 1.5K/4K Pkts/sec Tx/Rx rate on a dual-core 2.4GHz laptop.
%


\begin{figure}[tb]
  \centering
  \includegraphics[width=\columnwidth]{RxS_Structure.pdf}
%  \vspace{-0.25in}
  \caption{RxS Packet Structure}
  \label{fig:rxs}
  \vspace{-0.15in}
\end{figure}
